import type { RunningJobFromTask } from '../../config/types/workflowTypes.js';
import { type Payload, type PayloadRequest, type RunningJob, type TypedJobs } from '../../../index.js';
import { runAllJobs } from '../runAllJobs/index.js';
export declare const getJobsLocalAPI: (payload: Payload) => {
    queue: <TTaskOrWorkflowSlug extends keyof TypedJobs["tasks"] | keyof TypedJobs["workflows"]>(args: {
        input: TypedJobs["tasks"][TTaskOrWorkflowSlug]["input"];
        task: TTaskOrWorkflowSlug extends keyof TypedJobs["tasks"] ? TTaskOrWorkflowSlug : never;
        workflow?: never;
    } | {
        input: TypedJobs["workflows"][TTaskOrWorkflowSlug]["input"];
        task?: never;
        workflow: TTaskOrWorkflowSlug extends keyof TypedJobs["workflows"] ? TTaskOrWorkflowSlug : never;
    }) => Promise<TTaskOrWorkflowSlug extends keyof TypedJobs["workflows"] ? RunningJob<TTaskOrWorkflowSlug> : RunningJobFromTask<TTaskOrWorkflowSlug>>;
    run: (args?: {
        limit?: number;
        overrideAccess?: boolean;
        queue?: string;
        req?: PayloadRequest;
    }) => Promise<ReturnType<typeof runAllJobs>>;
};
//# sourceMappingURL=index.d.ts.map