import { createLocalReq } from '../../../index.js';
import { runAllJobs } from '../runAllJobs/index.js';
export const getJobsLocalAPI = (payload)=>({
        queue: async (args)=>{
            return await payload.create({
                collection: 'payload-jobs',
                data: {
                    input: args.input,
                    taskSlug: 'task' in args ? args.task : undefined,
                    workflowSlug: 'workflow' in args ? args.workflow : undefined
                }
            });
        // Type assertion is still needed here
        },
        run: async (args)=>{
            const newReq = args?.req ?? await createLocalReq({}, payload);
            const result = await runAllJobs({
                limit: args?.limit,
                overrideAccess: args?.overrideAccess !== false,
                queue: args?.queue,
                req: newReq
            });
            return result;
        }
    });

//# sourceMappingURL=index.js.map